/*
开发日期:2018.5.11
开发者:samt007
开发者联系邮件：samt007@qq.com
特别说明:该产品是一键购物助手的oem产品。详细的说明手册请看：快去买 http://kqmai.com
*/
//调试函数
debug_mode='N';
function debug(log){
	if (debug_mode=='Y') console.log(getSysDateFormat()+': '+log);
}
function initDebug(optDebugMode){
	debug_mode=optDebugMode;
}

function showMsg(msg){
	layer.msg(msg,{time: 8000,zIndex:9999999991})
}

function showAlert(msg,callback){
	layer.alert(msg,{zIndex:9999999991},callback)
}

//百度统计
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?84d45aec02d663cc61cbe1cb8f3b159f";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
  //console.log('百度统计！');
})();
	
// ajax factory 
function Ajax(url, options){
    var xhr = new XMLHttpRequest();
    xhr.onreadystatechange = function(){

        // complete
        if (xhr.readyState == 4) {
            if (xhr.status == 200) {
                rsp = JSON.parse(xhr.responseText);
                options.success(rsp);
            }
        }
    }
    xhr.open(options.method||'POST', url, true);

    return xhr;
}

//获取URL的host地址。
function getDomainFromUrl(url){
     var host = "null";
     if(typeof url == "undefined" || null == url)
          url = window.location.href.split('&')[0];
     var regex = /.*\:\/\/([^\/]*).*/;
     var match = url.match(regex);
     if(typeof match != "undefined" && null != match)
          host = match[1];
     //debug('host:'+host);
	 return host;
}

// 例子： 
// (new Date()).Format("yyyy-MM-dd hh:mm:ss.S") ==> 2006-07-02 08:09:04.423 
// (new Date()).Format("yyyy-M-d h:m:s.S")      ==> 2006-7-2 8:9:4.18 
Date.prototype.Format = function (fmt) { //author: meizz 
    var o = {
        "M+": this.getMonth() + 1, //月份 
        "d+": this.getDate(), //日 
        "h+": this.getHours(), //小时 
        "m+": this.getMinutes(), //分 
        "s+": this.getSeconds(), //秒 
        "q+": Math.floor((this.getMonth() + 3) / 3), //季度 
        "S": this.getMilliseconds() //毫秒 
    };
    if (/(y+)/.test(fmt)) fmt = fmt.replace(RegExp.$1, (this.getFullYear() + "").substr(4 - RegExp.$1.length));
    for (var k in o)
    if (new RegExp("(" + k + ")").test(fmt)) fmt = fmt.replace(RegExp.$1, (RegExp.$1.length == 1) ? (o[k]) : (("00" + o[k]).substr(("" + o[k]).length)));
    return fmt;
}

//封装的用来模拟点击按钮或者链接的功能
function clickObj(domObj) { 
	if (/msie/i.test(navigator.userAgent)) //IE 
	{ 
		domObj.fireEvent("onclick"); 
	} else { 
		var e = document.createEvent('MouseEvent'); 
		e.initEvent('click', false, false); 
		domObj.dispatchEvent(e); 
		//debug('MouseEvent auto clickObj!');
	}
} 

/*
https://www.cnblogs.com/gisblogs/p/5821665.html
http://blog.csdn.net/max229max/article/details/53931702
*/

function fireKeyEvent(el, evtType, keyCode) {
	var evtObj;
	if (document.createEvent) {
		if (window.KeyEvent) {//firefox 浏览器下模拟事件
			evtObj = document.createEvent('KeyEvents');
			evtObj.initKeyEvent(evtType, true, true, window, true, false, false, false, keyCode, 0);
		} else {//chrome 浏览器下模拟事件
			evtObj = document.createEvent('UIEvents');
			evtObj.initUIEvent(evtType, true, true, window, 1);

			delete evtObj.keyCode;
			if (typeof evtObj.keyCode === "undefined") {//为了模拟keycode
				Object.defineProperty(evtObj, "keyCode", { value: keyCode });                       
			} else {
				evtObj.key = String.fromCharCode(keyCode);
			}

			if (typeof evtObj.ctrlKey === 'undefined') {//为了模拟ctrl键
				Object.defineProperty(evtObj, "ctrlKey", { value: true });
			} else {
				evtObj.ctrlKey = true;
			}
		}
		el.dispatchEvent(evtObj);
	} else if (document.createEventObject) {//IE 浏览器下模拟事件
		evtObj = document.createEventObject();
		evtObj.keyCode = keyCode
		el.fireEvent('on' + evtType, evtObj);
	}
}

function randomNumber(min, max) {//随机数，包含下限，不包含上限
	var n = Math.floor(Math.random() * (max - min)) + min;
	return n;
}

function isTimeValidate(time){
    //var curTime = +new Date;
    return (+new Date) < (time); 
}

//为了处理问题:这个值无法传至下一个页面！因为是2个不同的作用域！可以考虑用setting的方法，或者用cookie的办法。
//最后，找到一个很好的办法，就是存储在插件的sessionStorage区域！
var storageMain = {
	/**
	 * 加载已有数据，根据key找对应的value
	 * 扩展一下，这个key改为一个对象。传去一个json对象！Value返回的也是一个json对象！
	 */
	 getItem: function(key,callback){
		 if(!key){
			 //debug('key is null! error!',options);
			 return false;
		 }
		 this.sendMessageBack(
			'get',
			{'key':key},
			function(response){
				if(response){
					if(response.status==404){
						debug('没有找到key'+key+' 对应的value值!');
						return false;
					}
					callback(response.value);
				}
			}
		 );
	 },
	/**
	 * 设定功能，将对应的key和value存到插件的background运行环境
	 */
	 setItem: function(key,value,callback){
		 if(!key){
			 debug('key is null!');
			 return false;
		 }
		 this.sendMessageBack(
			'set',
			{'key':key,'value':value},
			function(response){
				callback&&callback(response)
				if(response&&response.status==200){
					debug('key:'+key+',value:'+value+' set successfully!');
				}else{
					debug('key:'+key+',value:'+value+' set faild!status:'+response.status);
				}
			}
		 );
	 },
	 setJson: function(jsonObj,callback){
		 if(!jsonObj||typeof jsonObj!=='object'){
			 debug('key is null or param is not a obj!');
			 return false;
		 }
		 this.sendMessageBack(
			'setJson',
			jsonObj,
			function(response){
				callback&&callback(response)
			}
		 );
	 },
	/**
	 * 删除功能，将对应的key的值删除
	 */
	 delItem: function(key){
		 if(!key){
			 return false;
		 }
		 this.sendMessageBack(
			'del',
			{'key':key},
			function(response){
				if(response.status==200){
					debug('key:'+key+',errbuf:'+response.errbuf);
				}else{
					debug(response.errbuf);
				}
			}
		 );
	 },
	 sendMessageBack: function(strAction, dicData, callback){
		 chrome.extension.sendMessage({'action':strAction, 'data':dicData},callback);
	 },
}

//device:mobile/computer // getTmailMobileBuylink
function getTmailOrderBuylink(device,url,buyProp){
	var ret='',itemId,skuId='',quantity=1,urlArray;
	urlArray=url.split('?')[1].split('&');
	for(var i=0;i<=urlArray.length;i++){
		//debug(urlArray[i]);
		if(!urlArray[i]) continue;
		if(!itemId && urlArray[i].indexOf('id=')!=-1){
			itemId=urlArray[i].split('=')[1];
			if(isNaN(itemId)) itemId='';//不是数字则必须要清空
		}
		if(!skuId && urlArray[i].indexOf('skuId=')!=-1){
			skuId=urlArray[i].split('=')[1];
			if(isNaN(skuId)) skuId='';
		}
		if(itemId&&skuId) break;
	}
	if(buyProp&&buyProp.indexOf('&')!=-1){
		quantity=buyProp.split('&')[1];
		if(isNaN(quantity)) quantity=1;
	}
	debug('itemId:'+itemId+',skuId:'+skuId+',quantity:'+quantity);
	if(itemId){//有些是不需要选择品种的：&&skuId
		ret = device=='mobile' ? 
		'https://buy.m.tmall.com/order/confirmOrderWap.htm?_input_charset=utf-8&buyNow=true&etm=post&itemId='+itemId+'&skuId='+skuId+'&quantity='+quantity
		:'https://buy.tmall.com/order/confirm_order.htm?buy_param='+itemId+'_'+quantity+'_'+skuId+'&skuId='+skuId+'&from=item_detail';
	}
	return ret;
}

//获取天猫购物车的订单链接
function getTmailCartOrderBuylink(device,callback){
	//debug('device:'+device);
	var url = 'https://h5.m.taobao.com/cart/order.html?buyNow=false&buyParam=',item
	   ,itemBase = '&itemId_&quantity_&skuId_null_0_null_null_&cartId_null_null_null_0_null_buyerCondition~0~~dpbUpgrade~0~~cartCreateTime~&cartCreateTime_0_0_null_null_null_null_null_null_null_null_null'
	   ,cnt = 0;
	$('#content script').each(function(s,o){
		//console.log(s,o)
		if($(o).html().indexOf('try{var firstData =') !== -1){
			var html = $(o).html(), w = html.replace("try{var firstData =", ""), g = JSON.parse(w.slice(0, w.lastIndexOf("};"))+'}');
			//console.log(g);
			g.list&&g.list.length>0&&g.list.forEach(function(c) {
                //console.log(c);
				c.bundles&&c.bundles.length>0&&c.bundles[0].orders.forEach(function(od){
					//console.log(od);
					cnt++,item=itemBase.replace('&itemId',od.itemId).replace('&quantity',od.amount.now).replace('&skuId',od.skuId).replace('&cartId',od.cartId).replace('&cartCreateTime',1000*Math.floor(getServerTime()/1000))
					,cnt==1?(url+=item):(url+=','+item);
				})
            })
			console.log(url);
		}else{
			return false;
		}
	})
	callback && (cnt==0?callback(''):callback(url));
}

function getQuickBuyUrlLinkParams(options){
	var params='&quickBuyFlag=Y&orderBuyFlag=Y&clickOrder='+options.click_order+'&bookTimeBuy='+(new Date(options.bookTimeBuy).getTime())
	   +'&timeGap='+options.timeGap+'&leadTimeOfBookTime='+options.leadTimeOfBookTime+'&serverTime='+getServerTime()+'&maxReloadPageTimes='+options.maxReloadPageTimes;
	return params;
}

//待开发破解滑动验证！
function slidetounlock(){
	debug('进行滑动验证！');
	var obj = document.getElementById('nc_1_n1z')//移动元素
	,box = document.getElementById('nc_1_n1t')//移动元素所在的区间
	,boxRect = box.getBoundingClientRect()//区间的坐标
	,curLeft=boxRect.left + obj.offsetLeft
	,down = createEvent('mousedown', boxRect.left + obj.offsetLeft+5, boxRect.top + obj.offsetTop-5)
	,up = createEvent('mouseup')
	,rand=100+10*randomNumber(1,10)+randomNumber(1,10);
	setTimeout(function(){document.dispatchEvent(createEvent('mousedown',boxRect.left+obj.offsetLeft-randomNumber(10,20),boxRect.top+obj.offsetTop-randomNumber(20,30)));},10);
	setTimeout(function(){document.dispatchEvent(createEvent('mousedown',boxRect.left+obj.offsetLeft-randomNumber(1,10),boxRect.top+obj.offsetTop-randomNumber(15,30)));},50);
	setTimeout(function(){obj.dispatchEvent(down);},100);
	setTimeout(function(){curLeft=curLeft+rand; document.dispatchEvent(createEvent('mousemove',curLeft,boxRect.top+obj.offsetTop));},150);
	setTimeout(function(){curLeft=curLeft+440-rand; document.dispatchEvent(createEvent('mousemove',curLeft,boxRect.top+obj.offsetTop));},200);
}

function createEvent(eventName, ofsx, ofsy) {
	var evt = document.createEvent('MouseEvents');
	evt.initMouseEvent(eventName , true , false , null , 0 , 0 , 0 , ofsx, ofsy,  false, false , false, false, 0, null);
	return evt;
}

function getParamsFromlink(url){
	var params={},urlArray;
	if(url&&url.split('?')[1]){
		urlArray=url.split('?')[1].split('&');
		for(var i=0;i<=urlArray.length;i++){
			//debug(urlArray[i]);
			if(!urlArray[i]||urlArray[i].indexOf('=')==-1) continue;
			params[urlArray[i].split('=')[0]]=urlArray[i].split('=')[1];
		}
	}
	//debug('params:'+JSON.stringify(params));
	return params;
}

function cartPageDeal(options){
	setTimeout(function(){
		if(options.clickAddToCartPage=='Y'){
			debug('run the clickAddToCartPage!');
			var params=getParamsFromlink(window.location.href);
			if(params.id){
				window.location.href='https://detail.m.tmall.com/item.htm?id='+params.id+'&quickBuyFlag=Y&clickAddToCartPage=Y';
			}else{
				showAlert('非商品购买页面，不可以加入购物车！');
			}
		}
		if(options.clickToCartPage=='Y'){
			debug('run the clickToCartPage!');
			window.location.href='https://h5.m.taobao.com/mlapp/cart.html';
		}
	},400)
}

//获取系统时间(ms)
function getSysTime(){
	return (new Date()).getTime();//+new Date;//(new Date()).getTime();
}

function getSysDateFormat(){
	return (new Date()).Format("yyyy-MM-dd hh:mm:ss.S");
}

//获取淘宝时间
timeGap=0;
function getServerTime(){
	return ((new Date()).getTime() + timeGap);//+new Date
	//debug('timeGap:'+timeGap);
}

function getServerDateFormat(){
	return (new Date(getServerTime())).Format("yyyy-MM-dd hh:mm:ss.S");
}

function getServerDateFormat2(){
	return (new Date(getServerTime())).Format("yyyy-MM-dd hh:mm:ss");
}

function initServerTime(OptTimeGap){
	timeGap=OptTimeGap;
	debug('-->timeGap:'+timeGap+' ,ServerTime:'+getServerDateFormat());
}

//为了最准确可以显示时间给用户看(就是百分之99可以和电脑的时间对应)，用这个逻辑：
sysDateInervalId=undefined;
function showSysDT(sysDTObj){
	var nextSecGap=getServerTime()%1000;
	$(sysDTObj).html(getServerDateFormat2());//'<b>系统当前日期: </b>'+
	setTimeout(function(){
		$(sysDTObj).html(getServerDateFormat2());
		sysDateInervalId=setInterval(function(){
			$(sysDTObj).html(getServerDateFormat2());
		},1000);
	},nextSecGap);
	debug('getServerTime():'+getServerTime()+',nextSecGap:'+nextSecGap+',sysDateInervalId:'+sysDateInervalId);
}

function clearSysDT(){
	if(sysDateInervalId){
		clearInterval(sysDateInervalId);
		sysDateInervalId=undefined;
		debug('clearInterval:sysDateInervalId');
	}
}

function populateDom(selector,name,interval,maxTimes,callback,failCallback){
	var i=1;
	! function(e){
		! function n(){
			var selDom=$(selector)[0];
			//console.log(selDom);
			selDom !==undefined ? !function(){
				i==1 ? !debug('-->'+i+' times get ('+name+') Dom onece.') : !debug('-->'+i+' times get ('+name+') Dom interval.')
				callback && callback(selDom,selector);
			}() : setTimeout(function(){
				i++,i<=maxTimes ? n() : failCallback&&failCallback();
			},e)
		}()
	}(interval)
}

function populateBtn(btnSelector,btnName,interval,maxTimes,callback){//自动不断循环定位按钮
	populateDom(btnSelector,btnName,interval,maxTimes,callback)
}

function clickBtnTimes(btnObj,interval,maxTimes,failCallback){//自动不断循环定位按钮
	var n=1;
	if(btnObj){
		debug('@第 '+n+' 次点击提交按钮，点击时间:'+getServerDateFormat());
		btnObj.click();
	}
	function clickBtnRecursion(){
		n++;
		if(btnObj){
			btnObj.click();
			debug('$第 '+n+' 次点击提交按钮，点击时间:'+getServerDateFormat());
		}
		if(n<maxTimes){
			setTimeout(function(){clickBtnRecursion();},interval);
		}else{
			failCallback && setTimeout(function(){failCallback(btnObj);},interval*2);
		}
	}
	setTimeout(function(){clickBtnRecursion();},interval);
}

function clickBtnTimesBySeletor(btnSelector,interval,maxTimes){//自动不断循环定位按钮
	var n=1,btnObj;
	btnObj=$(btnSelector)[0];
	if(btnObj) btnObj.click();
	function clickBtnRecursion2(){
		btnObj=$(btnSelector)[0];
		n++;
		if(btnObj){
			btnObj.click();
			debug('$第 '+n+' 次点击提交按钮('+btnSelector+')，点击时间:'+getServerDateFormat());
		}
		if(n<maxTimes){
			setTimeout(function(){clickBtnRecursion2();},interval);
		}
	}
	setTimeout(function(){clickBtnRecursion2();},interval);
}

function clickBuyBtnTimesDyn(options,sour,interval,maxTimes,callback,failCallback){//自动不断循环动态定位按钮
	if(sour=='taobaoBuyPage'){
		populateBtn('.J_LinkBuy','淘宝购买按钮',interval,maxTimes,callback);
	}else if(sour=='tmallBuyPage'){
		populateBtnTmallBuyPage('#J_LinkBuy','天猫购买按钮',interval,maxTimes,callback,failCallback);
	}else if(sour=='cartPage'){
		cartPageSelectAll(getDomainFromUrl(),10,function(){//首先必须得全选再进行操作
			$('#J_Go')[0] ? populateBtn('#J_Go','电脑购物车购买按钮',interval,maxTimes,callback) 
			  : populateBtn($('.footer.f-fx>div>div')[3],'手机购物车购买按钮',interval,maxTimes,callback);
		},function(){
			//全选失败需要刷新购物车页面3次
			!sessionStorage['reloadPageTimes'] && (sessionStorage['reloadPageTimes']=0);
			debug('reloadPageTimes:'+sessionStorage['reloadPageTimes']+',maxReloadPageTimes:'+options.maxReloadPageTimes);
			parseInt(sessionStorage['reloadPageTimes'])||1 < parseInt(options.maxReloadPageTimes)||3 ? !function(){
				sessionStorage['reloadPageTimes']=parseInt(sessionStorage['reloadPageTimes'])+1;
				sessionStorage['timeOutBuy']='Y';
				debug('-->购物车全选失败!插件自动刷新第 '+sessionStorage['reloadPageTimes']+' 次。时间:'+getServerDateFormat());
				if(isNaN(sessionStorage['reloadPageTimes']||6) || parseInt(sessionStorage['reloadPageTimes']||6) >= 6 ){
					cleanTabStorage();
					debug('-->购物车全选失败!重试次数超过6次！');
					showAlert('<b>购物车全选失败!重试次数超过6次！</b><br/>感谢您使用一键购物助手！');
				}else{
					var urlLink=window.location.href;
					window.location.href=urlLink;
				}
			}():!function(){
				debug('-->购物车全选失败!');
				cleanTabStorage();
				showAlert('<b>购物车全选失败！</b><br/>感谢您使用一键购物助手！');
			}();
		})
	}else if(sour=='chaoshiBuyPage'){
		setTimeout(function(){
			debug('populateBtn-chaoshiBuyPage...');
			populateBtnTmallBuyPage('#J_LinkBasket','天猫超市购买按钮',interval,maxTimes,callback,failCallback);
		},500);//缓解由于ajax延迟刷新dom导致插件的bug
	}
	//debug('备注：如果自动循环 '+maxTimes+' 次都无法正常购买，说明本次自动购买失败！处理过程结束！');
}

function cartPageSelectAll(host,maxTimes,callback,failCallback){
	var i=1;
	! function n(){
		var countDom = host=='h5.m.taobao.com' ? $($('.footer.f-fx>div>div')[3]).find('span')[2] : $('#J_SelectedItemsCount')[0]
		if( countDom && parseInt($(countDom).html())!=0){
			callback && !callback() && !debug(i+' times after to successful select All-0');
			return;
		}
		var selectAllDom = host=='h5.m.taobao.com' ? $('.ft-cb').find('label')[0] : $('#J_SelectAll2 div.cart-checkbox')[0]
		   ,timeOut = host=='h5.m.taobao.com' ? 0 : 400,timeOutClick = host=='h5.m.taobao.com' ? 20 : 300;
		selectAllDom && countDom && !isNaN($(countDom).html()) ? !function(){
			//debug('item count:'+parseInt($(countDom).html())+',timeOut:'+timeOut);
			parseInt($(countDom).html())==0 ?  setTimeout(function(){
				var b=1;
				parseInt($(countDom).html())==0 ? !function(){
					debug(i+' times after to click select All');
					!selectAllDom.click() && !function m(){
						parseInt($(countDom).html())!=0 ? !function(){
							!debug(b+' times after to successful select All') && callback && callback();
						}() : setTimeout(function(){
							b++,b<=5 ? m() : failCallback&&failCallback();
						},timeOutClick)
					}()
				}(): !debug(i+' times after to successful select All-1') && callback && callback();
			},timeOut) : !debug(i+' times after to successful select All-2') && callback && callback();
		}() : setTimeout(function(){
			i++,i<=maxTimes ? n() : failCallback&&failCallback();
		},100);
	}()
}

function populateBtnTmallBuyPage(selector,name,interval,maxTimes,callback,failCallback){//自动不断循环定位按钮
	var i=1;
	! function(e){
		! function n(){
			var selDom=$(selector)[0];
			selDom !==undefined && $(selDom).parent().attr('class').indexOf("tb-hidden")==-1 ? !function(){//&& $('#J_ButtonWaitWrap')[0]===undefined
				i==1 ? !debug('-->'+i+' times get ('+name+') Dom onece.') : !debug('-->'+i+' times get ('+name+') Dom interval.')
				callback && callback(selDom,selector);
			}() : setTimeout(function(){
				i++,i<=maxTimes ? n() : failCallback&&failCallback();
			},e) && i==1 && buyPageShowLoading(e*maxTimes);
		}()
	}(interval)
}

//2016.10.24 新增功能，自动获取问题的答案！！
//如果在别的地方用，屏蔽这里的代码即可。
function getImgResult(urlStr,taobaoUser,licenseCode){
	var questionImg=urlStr.replace('http://','').split('/')[2];
	var basePath=urlStr.replace(questionImg,'');
	var result;
	$.ajax({
		async:false,
		type:'post', 
		data:JSON.stringify({'basePath':basePath,'questionImg':questionImg,'taobaoUser':taobaoUser,'licenseCode':licenseCode}),
		contentType:'application/json;charset=UTF-8',
		url:'http://59.36.15.120:8889/quick-buy/fnd/questionImg/getImgResult',
		dataType:'json',
		success: function (data) {
			debug(JSON.stringify(data));
			if(data.code=='0'&&data.obj&&data.obj.avalibleFlag=='Y'){
				result=data.obj.questionResult;
			}
		},
		error: function () {
			debug("获取Json数据失败");					
		}
	});
	//debug('result:'+result);
	return result;
}

function setImgResult(urlStr,result,description){
	var questionImg=urlStr.replace('http://','').split('/')[2];
	var basePath=urlStr.replace(questionImg,'');
	$.ajax({
		async:true,
		type:'post', 
		data:JSON.stringify({'basePath':basePath,'questionImg':questionImg,'questionResult':result,'description':description}),
		contentType:'application/json;charset=UTF-8',
		url:'http://59.36.15.120:8889/quick-buy/fnd/questionImg/setImgResult',
		dataType:'json',
		success: function (data) {
			debug(JSON.stringify(data));
		},
		error: function () {
			debug("获取Json数据失败");					
		}
	});
	debug(urlStr+' -->success to set result:'+result);
}

//判断用户是否可以用miaosha助手功能
function checkTaobaoUserLicense(taobaoUser,licenseCode){
	var result;
	$.ajax({
		async:false,
		type:'post', 
		data:JSON.stringify({'taobaoUser':taobaoUser,'licenseCode':licenseCode}),
		contentType:'application/json;charset=UTF-8',
		url:'http://59.36.15.120:8889/quick-buy/fnd/miaoLicense/checkTaobaoUserLicense',
		dataType:'json',
		success: function (data) {
			debug(data);
			result=data;
		},
		error: function () {
			debug("获取Json数据失败");					
		}
	});
	return result;
}

function getMiaoId(){
	var miaoId;
	var host=getDomainFromUrl();
	var url=window.location.href;
	if(host=='miao.item.taobao.com'){
		url=url.replace('http:\/\/miao.item.taobao.com\/','');
		miaoId=url.split('?')[0].split('.')[0];
	}else if(host=='detail.tmall.com'){
		miaoId=url.split('&')[1].replace('id=','');
	}
	//debug(url);
	return miaoId;
}

//返回的是一个json对象！
//{"lgin":false,"sign":"","qst":"","stock":0,"now":1477615860275,"refresh":800}
function getMiaoData(miaoId){
	var result={};
	$.ajax({
		async:false,
		type:'get', 
		data:'miaoId='+miaoId,
		url:'http://192.168.88.35:8080/questionImg/question/getMiaoData.do',
		dataType:'json',
		success: function (data) {
			//debug(data.retcode+':'+data.param1);
			result=data;
		},
		error: function () {
			debug("获取Json数据失败");					
		}
	});
	//debug('getMiaoData result:'+JSON.stringify(result));
	return result;
}

//自动根据关键字选择属性的封装 2016.10.25
//适用于淘宝和天猫所有页面的自动购买。以后按需可以添加京东等的网站自动购物。
//逻辑：判断每一个选项是否有选择了，如果有选择则不管，没有则默认选择第一个！执行时间约40ms~50ms
function autoSelectProp(sour,buyProp,options){
	var buyPropSet,amount;
	if(buyProp&&buyProp.indexOf('&')>-1){
		buyPropSet=buyProp.split('&')[0];
		amount=buyProp.split('&')[1];
	}else{
		buyPropSet=buyProp;
	}
	$('.tb-skin dl').each(function(i,dlObj){
		//debug('=====处理第['+i+']个节点：'+$(dlObj).find('dt').html()+'=====');
		if($(dlObj).attr('class').indexOf('amount')!=-1){
			if(amount){
				//debug('输入数量:'+amount)
				if(!isNaN(amount)){
					//console.log($('input.mui-amount-input')[0]);
					if($('input.mui-amount-input')[0]){
						$('input.mui-amount-input')[0].focus();
						$('input.mui-amount-input').val(parseInt(amount));
						var cCode = amount.trim().charCodeAt(0);
						fireKeyEvent($('input.mui-amount-input')[0], "keyup", cCode);
					} 
					$('#J_IptAmount')[0] && $('#J_IptAmount').val(amount);
				}
			}
			//debug('数量节点之后都不需要自动处理!',options.debug_mode);//数量之后的都不处理了
			return false;//相当于break的效果！
		}
		//再来一个循环，逐一寻找每一个li的元素，看是否有选择了。
		var isSel=false;//这个是判断dl元素下面的所有子li元素，是否有选择了其中1项！
		var isKeyWordChoose=false;//判断是属于keyword选择的！这个选择的优先级比默认选择的优先级要高！
		var autoSelObj=undefined;
		var backObj=undefined;//获取第一个可以自动选择的对象。以便万一找不到合适的，也有个备胎！
		//var currSelObj=undefined;
		$(dlObj).find('dd ul li').each(function(n,liObj){
			var liClassName=$(liObj).attr('class')||'';
			var liPropName;
			liPropName=($(liObj).find('span').html()||$(liObj).find('a').html())||'';
			//debug('第['+n+']次遍历li节点信息:liClassName:'+liClassName+',liPropName:'+liPropName,options.debug_mode);
			if(!(backObj)&&liClassName.indexOf('tb-out-of-stock')==-1){//首先记录下备胎。注意：无库存的不允许选择
				backObj=liObj;
				//debug('  backObj:'+$(backObj).find('span').html(),options.debug_mode);
			}
			//再执行自动选择。要参考前面提供的参数列表
			//首先，无库存的必须不可以选择。其次，如果有出现2个一样的，则选第一个即可。
			if(!(autoSelObj)&&liClassName.indexOf('tb-out-of-stock')==-1){//无库存的不允许选择
				if(buyPropSet&&buyPropSet.length>0){
					//debug('buyPropSet:'+buyPropSet);
					$.each(buyPropSet.split(','),function(idx,keyWord){
						//debug('liPropName:'+liPropName+',keyword:'+keyWord);
						if(liPropName.indexOf(keyWord)!=-1){//包含关键字的则自动选择！
							autoSelObj=liObj;
							isKeyWordChoose=true;
							//debug('  根据关键字('+keyWord+')选择属性:'+liPropName+' !',options.debug_mode);
							return false;//注意：return false会自动跳出最近的一层function的代码！
						}
					});
				}else{
					autoSelObj=liObj;
				}
				//debug('  autoSelObj:'+$(autoSelObj).find('span').html(),options.debug_mode);
			}
			if(liClassName.length>0&&(liClassName.indexOf('current')!=-1||liClassName.indexOf('selected')!=-1)){
				isSel=true;
				//currSelObj=liObj;
				if(isKeyWordChoose) isKeyWordChoose=false;//如果刚刚好默认选择的又是关键字选择的，则就用默认选择的即可。
			}
			//debug('节点处理完毕',options.debug_mode);
		});
		//如果没有选中，并且自动选择的没有，但是备胎有，则选择备胎！
		if(!(isSel)&&!autoSelObj&&backObj){
			autoSelObj=backObj;
			//debug('选择了备胎！',options.debug_mode);
		}
		//如果没选中的,则自动选一个咯
		//逻辑是：如果有关键字选择的，则这个优先级是最高的。如果没有，则看是否有默认选择。没有默认选择的才需要重新选择一次！
		if(isKeyWordChoose||!(isSel)){
			//用这个.find(':nth-child(1)')好像选择的是最后一个Li，奇怪
			//$(dlObj).find('dd ul li:not([class*="tb-out-of-stock"])').find(':nth-child(1)').click();
			if(autoSelObj){
				//对于天猫，直接在li模拟做点击事件还不起作用！通过研究发现，模拟点击a标签的事件，居然成功选中了！
				if($(autoSelObj).find('a')[0]){
					$(autoSelObj).find('a')[0].click();
					//debug('-->自动选择节点的值:'+$(autoSelObj).find('span').html(),options.debug_mode);
				}
			}
		}else{
			//debug('-->该节点的选项已经有默认选择！或者默认值=关键字选择的值！',options.debug_mode);
		}
	});
}

//刷新倒计时界面的时间
function refTime(time_distance){
	var int_day, int_hour, int_minute, int_second;
	int_day = Math.floor(time_distance/86400000)
	time_distance -= int_day * 86400000;
	int_hour = Math.floor(time_distance/3600000)
	time_distance -= int_hour * 3600000; 
	int_minute = Math.floor(time_distance/60000)   
	time_distance -= int_minute * 60000;
	int_second = Math.floor(time_distance/1000)   
	if(int_hour < 10) int_hour = "0" + int_hour; 
	if(int_minute < 10) int_minute = "0" + int_minute; 
	if(int_second < 10) int_second = "0" + int_second;

	// 显示倒计时效果      
	$('#times_day').html(int_day);
	$('#times_hour').html(int_hour);
	$('#times_minute').html(int_minute);
	$('#times_second').html(int_second);
}

function showOrderNotification(options){
	//添加提示音通知：
	if (Notification.permission == 'granted') {
		if(options.bell_alert=='Y'){
			debug('播放提示音！');
			var bellURL = chrome.extension.getURL("include/19_Morning_breeze.ogg");
			var audio = new Audio(bellURL);
			audio.loop = false;
			audio.play();
		}
		if(options.msg_alert=='Y'){
			debug('显示提示信息！');
			var imgPath=$('img[class="info-img"]').attr('src');
			var itemName=$('a[class="info-title"]').html();
			if(!imgPath){
				imgPath=$('img[data-mm="openitem_pic"]').attr('src')||'';
				itemName=$('a[class="img"]').attr('title')||'';
			}
			if(!itemName){
				imgPath=$('div[class="img"]').css('backgroundImage').replace('url("','').replace('")','')||'';
				itemName=$('div[class="title"]').html()||'';
			}
			var notiBody="你好！该物品("+itemName+")已经购买成功啦!请速度登陆淘宝进行付款！\n感谢您使用淘宝自动购买助手。";
			var notification = new Notification('淘宝自动购买助手通知',{icon:imgPath,body:notiBody});
		}
	}else{
		Notification.requestPermission();
		showMsg('物品已经自动购买成功！');
	}
}

