
   
// 初始化
if (!localStorage['miaoTime'] && !localStorage['miaoData']) {
    localStorage['miaoTime'] = '[0,0,0]';
    localStorage['miaoData'] = '[{"title": "","img": "","link": "","price": "","miaoPrice": ""}]';
}

// 等于true为加载页面自动出发一键购物的状态
var autoStartFlag = (localStorage['ref_auto_buy'] == 'Y')
   ,quickBuyTime = JSON.parse(localStorage['miaoTime'])
   ,quickBuyData = JSON.parse(localStorage['miaoData'])
   ,quickBuyAds;

//console.log(localStorage['miaoData']);

// DOM ready
window.addEventListener('DOMContentLoaded',function(){
    var template = $('#J-dataTemplate')[0].innerHTML;
    var oQuickBuyList = $('#J-quickBuyList')[0];
    var oQuickBuyTime = $('#J-quickBuyStartTime')[0];
    var oQuickBuyAds = $('#J-ads')[0]
    var oQuickBuyMore = $('.quickBuyMore')[0];
    var oSponsor = $('#sponsor')[0];
	
	//显示版本
	if (localStorage['currentVersion']) {
        $('.version').html('v'+localStorage['currentVersion']);
    }
	
	//执行一键购物
	//console.log($('.runQuickBuy')[0]);
	$('.runQuickBuy').click(function(){
		console.log('runQuickBuy!');
		localStorage['click_auto_buy']='Y';
		chrome.tabs.executeScript(null
		,{file: "content_script.js"}
		,function(){
			setTimeout(function(){
				localStorage['click_auto_buy']='N';
				window.close();
			},100);
		});
	});
	$('.clickAddToCartPage').click(function(){
		console.log('clickAddToCartPage!');
		localStorage['clickAddToCartPage']='Y';
		chrome.tabs.executeScript(null
		,{file: "content_script.js"}
		,function(){
			setTimeout(function(){
				localStorage['clickAddToCartPage']='N';
				window.close();
			},100);
		});
	});
	$('.clickToCartPage').click(function(){
		console.log('clickToCartPage!');
		localStorage['clickToCartPage']='Y';
		chrome.tabs.executeScript(null
		,{file: "content_script.js"}
		,function(){
			setTimeout(function(){
				localStorage['clickToCartPage']='N';
				window.close();
			},100);
		});
	});

    //console.log('quickBuyh:'+quickBuyTime[1]+' quickBuym:'+quickBuyTime[2])

    // 展示更多秒杀’按钮
    if (localStorage['miaoMore']) {
        oQuickBuyMore.href = localStorage['miaoMore'];
        show(oQuickBuyMore);
    } else {
        hide(oQuickBuyMore);
    }

    // 展示sponsor内容
    if (localStorage['sponsor']) {
        oSponsor.innerHTML = localStorage['sponsor'];
        show(oSponsor);
    } else {
        hide(oSponsor);
    }

    // always hide icon badge after popup.htm shows
    chrome.browserAction.setBadgeText({text: ''});
    localStorage['badge'] = 'hide';

    console.log('isDisplayInfo ' + localStorage['isDisplayInfo'])
    console.log('miaoTime ' + localStorage['miaoTime'])
    //console.log('quickBuyData ' + localStorage['miaoData'])

    if ( isTimeValidate(JSON.parse(localStorage['miaoTime'])[0]*1000) && localStorage['isDisplayInfo'] != 'false' ) {

        show($('#J-quickBuySummary')[0]);
        hide($("#J-quickBuyList .loading")[0]);

        // show quickBuy items
        oQuickBuyTime.innerText = quickBuyTime[1] + ":" + quickBuyTime[2];
        quickBuyData.forEach(function(v, i){
			if(!v.miaoPrice){
				v.priceHidden='fn-hide';
			}
            var listItem = document.createElement('li');
            listItem.innerHTML = parseTemplate(v, template);
            oQuickBuyList.appendChild(listItem);
        })
    } else { // no quickBuy items info available
        console.log('no quickBuy items info available');
        hide($('#J-quickBuySummary')[0]);
        hide($("#J-quickBuyList .loading")[0]);
        show($("#J-quickBuyList .noItems")[0]);
    }

    if (localStorage['miaoAds']) {
        quickBuyAds = JSON.parse(localStorage['miaoAds'])

        quickBuyAds.forEach(function(item, index) {
            var listItem = document.createElement('li')
			if(!item.miaoPrice){
				item.priceHidden='fn-hide';
			}

            listItem.innerHTML = parseTemplate(item, template)
            oQuickBuyAds.appendChild(listItem)
        })
        show(oQuickBuyAds)
    } 

    /*if (autoStartFlag) {
        hide($("#status .loading")[0]);
        hide($("#status .fail")[0]);
        show($("#status .success")[0]);
    } else {
        hide($("#status .loading")[0]);
        show($("#status .fail")[0]);
        hide($("#status .success")[0]);
    }*/
	hide($("#status .loading")[0]);
	hide($("#status .fail")[0]);
	show($("#status .success")[0]);

    // 有可用更新
    if (localStorage['currentVersion'] < localStorage['latestVersion']) {
        console.log('update available')
        hide($("#status .fail")[0]);
        hide($("#status .success")[0]);
        show($("#status .update")[0]);
    }

    // sponsor tracker
    /*if ($('#sponsor a').length > 0) {
        on($('#sponsor a')[0], 'click', function(){
            _gaq.push(['_trackPageview', '/popup/sponsor_top'])
        })
    }*/

}, false);

/* 解析HTML模版
 * @param {Object} 数据对象
 * @param {String} 数据模版数组
 * @return {String} 解析后的数据字符串
 * */
function parseTemplate(data, template){
    var _template = template;

    for (var i in data) {
        while (_template.search("{%" + i + "}") != -1) {
            _template = _template.replace("{%" + i + "}", data[i]);
        }
    }

    return _template;
}

_hmt.push(['_trackEvent', '秒杀助手II插件', 'click', '点击图标']); 

function hide(dom) {
	$(dom).addClass("fn-hide");
}

function show(dom) {
	$(dom).removeClass("fn-hide");  
}